//===-- COM_slltod.S - Implement __floatdidf-----------------------------------===//
//
// Part of the LLVM Project, under the Apache License v2.0 with LLVM Exceptions.
// See https://llvm.org/LICENSE.txt for license information.
// SPDX-License-Identifier: Apache-2.0 WITH LLVM-exception
//
//===----------------------------------------------------------------------===//
//
// This file implements __floatdidf for the compiler_rt library.
//
//===----------------------------------------------------------------------===//

  .file   "COM_slltod.S"
  .extern __REL_lltod
  .extern __REL_llrev

  .text

  .globl __COM_slltod
  .type  __COM_slltod,@function
__COM_slltod:
  clrb  b   ; store sign (positive)
  push  ax
  movw  ax,sp
  addw  ax,#6
  movw  hl,ax
  
  mov a,[hl+7]  ; store the most significant byte of the input value in the a register
  mov1  cy,a.7
  bnc $0f   ; if the sign bit is 0 (positive), no sign conversion is performed
  
  ; sign inversion
  call  !!__REL_llrev
  oneb  b   ; store sign (negative)
0:
  pop de
  br  !!__REL_lltod
.Lfunc_end1:
  .size __COM_slltod, .Lfunc_end1-__COM_slltod

  .weak ___floatdidf
  .type ___floatdidf,@function
  .set  ___floatdidf, __COM_slltod
